<?php
namespace mas;

class Icon {
    function __construct() {
        add_filter( 'elementor/icons_manager/additional_tabs', [$this, 'add_mas_icons'] );
    }

    function add_mas_icons( $tabs = [] ) {

        $tabs['mas-icon'] = [
            'name'          => 'mas-icon',
            'label'         => __( 'Mthemeus Icons', 'mas' ),
            'url'           => MAS_ADDONS_ASSETS . '/css/mas-icon.css',
            'enqueue'       => [MAS_ADDONS_ASSETS . '/css/mas-icon.css'],
            'prefix'        => 'mas-',
            'displayPrefix' => '',
            'labelIcon'     => 'fas fa-folder-open',
            'ver'           => '1.0.0',
            'icons'         => $this->icons(), //$icons from icons.php
        ];

        return $tabs;
    }

    function icons() {
        $icon = [

            'cloud-download-95',
            'home-minimal',
            'single-04',
            'users-mm',
            'webpage',
            'layout-25',
            'analytics',
            'chart-pie-36',
            'chart-bar-33',
            'single-copy-06',
            'home',
            'bell-53',
            'email-84',
            'send',
            'at-sign',
            'edit-72',
            'tail-right',
            'minimal-right',
            'tail-left',
            'minimal-left',
            'tail-up',
            'minimal-up',
            'minimal-down',
            'tail-down',
            'settings-gear-64',
            'settings',
            'menu-dots',
            'funnel-40',
            'filter',
            'preferences-circle',
            'check-2',
            'cart-simple',
            'cart-9',
            'card-update',
            'basket',
            'check-circle-07',
            'simple-remove',
            'circle-remove',
            'alert-circle-exc',
            'bug',
            'share-66',
            'time',
            'coffee',
            'smile',
            'sad',
            'broken-heart',
            'pin-3',
            'marker-3',
            'globe-2',
            'world-2',
            'phone-2',
            'check-square-11',
            'wallet-90',
            'credit-card',
            'payment',
            'tag',
            'tag-cut',
            'flag-diagonal-33',
            'triangle-right-17',
            'puzzle-10',
            'triangle-right-17-2',
            'btn-play',
            'btn-play-2',
            'menu-34',
            'menu-left-2',
            'heart-2-2',
            'l-settings',
            'book-open-2',
            'layers-3',
            'google',
            'logo-pinterest',
            'logo-dribbble',
            'tablet-mobile',
            'house-search-engine',
            'house-pricing',
            'pulse-chart',
            'plug',
            'app-store',
            'power-level',
            'window-add',
            'form',
            'folder-15',
            'lock',
            'unlocked',
            'e-reader',
            'layout-grid',
            'single-copies',
            'bag',
            'shield',
            'security',
            'system-update',
            'privacy',
            'translation',
            'credit-locked',
            'apartment',
            'eye-17',
            'bookmark-2',
            'pantone',
            'trash-simple',
            'phone-call-end',
            'phone-call',
            'call-doctor',
            'swap-vertical',
            'swap-horizontal',
            'simple-add',
            'reload',
            'loop-83',
            'c-question',
            'alert',
            'cloud-download-93',
            'migration',
            'cloud-upload-96',
            'archive',
            'calendar-60',
            'opening-times',
            'calendar-check-62',
            'camera',
            'ungroup',
            'share-2',
            'world',
            'sound',
            'volume-mute',
            'sound-wave',
            'preferences-circle-rotate',
            'link-72',
            'link-broken-70',
            'link-69',
            'newsletter',
            'trend-up',
            'trend-down',
            'c-info',
            'shape-arrow',
            'circle-simple-up',
            'circle-simple-right',
            'circle-simple-left',
            'circle-simple-down',
            'check-circle-08',
            'circle-add',
            'zoom-in',
            'zoom-out',
            'zoom-2',
            'a-star',
            'a-security',
            'a-add',
            'data-download',
            'data-upload',
            'attach-87-1',
            'print',
            'round-dollar',
            'currency-dollar',
            'select-84',
            'chat-round',
            'chat-33',
            'sun',
            'moon',
            'code',
            'lightning',
            'camera-flash',
            'edit-brightness',
            'a-remove',
            'a-delete',
            'dock-top',
            'board-2',
            'corner-left-round',
            'bulb-63',
            'document',
            'chart-growth',
            'logout',
            'key-26',
            'bag-09',
            'basket-simple',
            'basket-simple-add',
            'cursor-48',
            'microphone',
            'notification-69',
            'pc',
            'phone-camera-front',
            'p-check',
            'e-reader-1',
            'microsoft',
            'layout-11',
            'row-table',
            'shape-star',
            'star',
            'js-console',
            'folder-chart-bar',
            'chart-bars',
            'chart-bar-32',
            'menu-right',
            'diag-top-left',
            'gps',
            'double-right',
            'double-left',
            'energy',
            'flame',
            'like-2',
            'thumb-down',
            'tool-hand',
            'screen-touch',
            'stretch',
            'pinch',
            'move-05',
            'upload-data',
            'music-note',
            'spaceship',
            'send-2',
            'send-1',
            'wifi',
            'server-rack',
            'dresser-3',
            'cloud-25',
            'database',
            'file-archive',
            'file-download-3',
            'drawer',
            'block',
            'calculator',
            'wand-11',
            'cupcake',
            'muffin',
            'popcorn',
            'video',
            'shuffle-98',
            'bill',
            'receipt-list-43',
            'signal-2',
            'book',
            'agenda-bookmark',
            'books',
            'book-open-2-1',
            'pencil-47',
            'chef-hat',
            'simple-delete',
            'logo-linkedin',
            'logo-facebook',
            'logo-fb-simple-1',
            'logo-twitter-1',
            'logo-instagram-1',
            'logo-pinterest-1',
            'box-3d-50',
            'delivery',
            'h-dashboard',
            'power-level-1',
            'time-3-1',
            'hourglass',
            'biochemistry',
            'cpu',
            'ai',
            'app-store-1',
            'questionnaire',
            'bicep',
            'expand',
            'transform-2d',
            'maximize',
            'window-maximize',
            'floor',
            'floors',
            'water-surface',
            'wallet-43',
            'analytics-88',
            'favourite-add-32',
            'survey',
            'face-recognition',
        ];
        return $icon;
    }
}

new Icon();