<?php

	if (!defined('ABSPATH')) {
		exit;
	}

class Techza_Hero_slider_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return 'Techza_Hero_slider';
	}

	public function get_title() {
		return esc_html__( 'Techza Hero Slider', 'techza-hp' );
	}

	public function get_icon() {
		return 'eicon-post-slider';
	}

	public function get_categories() {
		return [ 'techza-addons' ];
	}

	public function get_keywords() {
		return [ 'text', 'animate', 'infinite', ' slider' ];
	}

  protected function register_controls() {

		$this->start_controls_section(
			'content_section',
			[
				'label' => esc_html__( 'Content', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);


 	$this->add_responsive_control(
            'content_align',
            [
                'label' => __( 'Alignment', 'techza-hp' ),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'options' => [
                    'left' => [
                        'title' => __( 'Left', 'techza-hp' ),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => __( 'Center', 'techza-hp' ),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => __( 'Right', 'techza-hp' ),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'left',
                'selectors' => [
                    '{{WRAPPER}} .techza-slider-item' => 'text-align: {{VALUE}};',
                ],
            ]
        );

    $repeater = new \Elementor\Repeater();


    	$repeater->add_control(
            'h_bg_image',
            [
                'label'       => __( 'Background Image', 'techza-hp' ),
                'type'        => \Elementor\Controls_Manager::MEDIA,
            ]
        );

        $repeater->add_control(
			'techza_h_sub_title',
			[
				'label' => esc_html__( 'Sub Title', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'default' => esc_html__( 'sub title', 'techza-hp' ),
				'placeholder' => esc_html__( 'Type your title here', 'techza-hp' ),
				'label_block' => true,
				'separator' => 'before',
			]
		);

		$repeater->add_control(
			'techza_h_title',
			[
				'label' => esc_html__( 'Title', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'default' => esc_html__( 'title', 'techza-hp' ),
				'placeholder' => esc_html__( 'Type your title here', 'techza-hp' ),
				'label_block' => true,
				'separator' => 'before',
			]
		);

		$repeater->add_control(
            'techza_h_discription',
            [
                'label'       => __( 'Discription', 'techza-hp' ),
                'type'        => \Elementor\Controls_Manager::TEXTAREA,
                'label_block' => true,
                'default'     => __('Techmo is an IT solution set of services, software, or hardware bundled together and designed to help businesses manage complex technology operations', 'techza-hp'),
            ]
        );

		$repeater->add_control(
			'techza_h_btn',
			[
				'label' => esc_html__( 'Button', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'Free Consultation', 'techza-hp' ),
				'placeholder' => esc_html__( 'Type your title here', 'techza-hp' ),
				'label_block' => true,
				'separator' => 'before',
			]
		);
		$repeater->add_control(
			'techza_h_btn_link',
			[
				'label' => esc_html__( 'Link', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::URL,
				'placeholder' => esc_html__( 'https://your-link.com', 'techza-hp' ),
				'default' => [
					'url' => '',
					'is_external' => true,
					'nofollow' => true,
					'custom_attributes' => '',
				],
				'label_block' => true,
			]
		);

		$this->add_control(
			'techza_h_slider_list',
			[
				'label' => esc_html__( 'Repeater List', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [
					[
						'h_bg_image' => esc_html__( 'Image', 'techza-hp' ),
						'techza_h_sub_title' => esc_html__( 'Meta Frog Club: VIP Sale', 'techza-hp' ),
						'techza_h_title' => esc_html__( 'Meta Frog Club: VIP Sale', 'techza-hp' ),
						'techza_h_discription' => esc_html__( 'Description', 'techza-hp' ),
						'techza_h_btn' => esc_html__( 'Free Consultation', 'techza-hp' ),
						'techza_h_btn_link' => esc_html__( '#', 'techza-hp' ),
					],
				
				],
			]
		);


		$this->end_controls_section();

		// slider arrow

		$this->start_controls_section(
			'slider_content_section',
			[
				'label' => esc_html__( 'Arrows', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'h_arrow_prev_icon',
			[
				'label' => esc_html__( 'Slider Icon Left', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::ICONS,
				'default' => [
					'value' => 'fas fa-star',
					'library' => 'solid',
				],
			]
		);

		$this->add_control(
			'h_arrow_next_icon',
			[
				'label' => esc_html__( 'Slider Icon Right', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::ICONS,
				'default' => [
					'value' => 'fas fa-star',
					'library' => 'solid',
				],
			]
		);

		$this->end_controls_section();

		// slider Setting

		$this->start_controls_section(
			'slider_setting_section',
			[
				'label' => esc_html__( 'Setting', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'autoplay',
			[
					'label' => __('Auto Play?', 'techza-hp'),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => __('Show', 'techza-hp'),
					'label_off' => __('Hide', 'techza-hp'),
					'return_value' => 'yes',
					'default' => 'yes',
			]
		);
		$this->add_control(
			'arrows',
			[
					'label' => __('Show arrows?', 'techza-hp'),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => __('Show', 'techza-hp'),
					'label_off' => __('Hide', 'techza-hp'),
					'return_value' => 'yes',
					'default' => 'yes',
			]
		);



		$this->end_controls_section();

		// start style parts

		// Image
		$this->start_controls_section(
			'h_image_style',
			[
				'label' => esc_html__( 'Background Overly', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'h_background',
				'label' => esc_html__( 'Background', 'techza-hp' ),
				'types' => [ 'classic', 'gradient', 'video' ],
				'selector' => '{{WRAPPER}} .techza-slider-item:before',
			]
		);

		$this->add_responsive_control(
			'h_area_padding',
			[
				'label' => esc_html__( 'Padding', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-slider-item' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
			// end image style


			// Title
		$this->start_controls_section(
			'h_sub_title_style',
			[
				'label' => esc_html__( 'Sub Title', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_control(
			'h_sub_title_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-hero-content h5' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'h_sub_title_typography',
				'selector' => '{{WRAPPER}} .techza-hero-content h5',
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Text_Shadow::get_type(),
			[
				'name' => 'h_sub_title_text_shadow',
				'label' => esc_html__( 'Text Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-hero-content h5',
			]
		);

		$this->add_control(
			'h_sub_title_margin',
			[
				'label' => esc_html__( 'Margin', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-hero-content h5' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End title style

			// Title
		$this->start_controls_section(
			'h_title_style',
			[
				'label' => esc_html__( 'Title', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_control(
			'h_title_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-hero-content h1' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'h_title_typography',
				'selector' => '{{WRAPPER}} .techza-hero-content h1',
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Text_Shadow::get_type(),
			[
				'name' => 'h_title_text_shadow',
				'label' => esc_html__( 'Text Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-hero-content h1',
			]
		);

		$this->add_control(
			'h_title_margin',
			[
				'label' => esc_html__( 'Margin', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-hero-content h1' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End title style

		// Descriptions 
		$this->start_controls_section(
			'h_descriptions_style',
			[
				'label' => esc_html__( 'Description', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_control(
			'h_descriptions_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-hero-content p' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'h_descriptions_typography',
				'selector' => '{{WRAPPER}} .techza-hero-content p',
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Text_Shadow::get_type(),
			[
				'name' => 'h_descriptions_text_shadow',
				'label' => esc_html__( 'Text Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-hero-content p',
			]
		);

		$this->add_control(
			'h_descriptions_margin',
			[
				'label' => esc_html__( 'Margin', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-hero-content p' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End title style


		// Content box 
		$this->start_controls_section(
			'h_content_box_style',
			[
				'label' => esc_html__( 'Content Box', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_responsive_control(
			'content_width',
			[
				'label' => esc_html__( 'Width', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'default' => [
					'unit' => '%',
					'size' => 100,
				],
				'selectors' => [
					'{{WRAPPER}} .techza-hero-content' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End title style



		// Button
		$this->start_controls_section(
			'h_btn_style',
			[
				'label' => esc_html__( 'Button', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->start_controls_tabs(
			'h_btn_style_tabs'
		);

		$this->start_controls_tab(
			'btn_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'techza-hp' ),
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'h_btn_typography',
				'selector' => '{{WRAPPER}} .techza-hero-btn',
			]
		);

		$this->add_control(
            'h_btn_background',
            [
                'label'     => __('Background', 'techza-hp'),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .techza-hero-btn' => 'background-color: {{VALUE}}',
                ],
            ]
        );

		$this->add_control(
			'h_btn_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-hero-btn' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'h_btn_border',
				'label' => esc_html__( 'Border', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-hero-btn',
			]
		);

		$this->add_control(
			'h_btn_border_radius',
			[
				'label' => esc_html__( 'Border Radius', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-hero-btn' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'h_btn_box_shadow',
				'label' => esc_html__( 'Box Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-hero-btn',
			]
		);

		$this->add_responsive_control(
			'h_btn_padding',
			[
				'label' => esc_html__( 'Padding', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-hero-btn' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->add_responsive_control(
			'h_btn_margin',
			[
				'label' => esc_html__( 'Margin', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-hero-btn' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_tab();
		// End button

		
		// btn hover

		$this->start_controls_tab(
			'btn_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'techza-hp' ),
			]
		);

		$this->add_control(
            'h_hover_btn_background',
            [
                'label'     => __('Background', 'techza-hp'),
                'type'      => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .techza-hero-btn:hover' => 'background-color: {{VALUE}}',
                ],
            ]
        );

		$this->add_control(
			'h_hover_btn_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-hero-btn:hover' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'h_hover_btn_border',
				'label' => esc_html__( 'Border', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-hero-btn:hover',
			]
		);


		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'h_hover_btn_box_shadow',
				'label' => esc_html__( 'Box Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-hero-btn:hover',
			]
		);

		$this->end_controls_tabs();
		
		$this->end_controls_section();

		// End button style


		// slider arrows
		$this->start_controls_section(
			'icon_style_section',
			[
				'label' => esc_html__( 'Arrows', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->start_controls_tabs(
			'arrows_style_tabs'
		);

		$this->start_controls_tab(
			'arrow_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'techza-hp' ),
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'arrow_background',
				'label' => esc_html__( 'Background', 'techza-hp' ),
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .hero-slider-arrow button',
			]
		);

		$this->add_control(
			'arrow_fill_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button i' => 'color: {{VALUE}}',
					'{{WRAPPER}} .hero-slider-arrow button path' => 'fill: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'arrow_stroke_color',
			[
				'label' => esc_html__( 'Stroke Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button path' => 'stroke: {{VALUE}}',
				],
			]
		);

		$this->add_responsive_control(
			'arrows_width',
			[
				'label' => esc_html__( 'Width', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
				
				],
		
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_responsive_control(
			'arrows_height',
			[
				'label' => esc_html__( 'Height', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
				
				],
		
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button' => 'height: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_control(
			'arrows_size',
			[
				'label' => esc_html__( 'Size', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px'],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 100,
						'step' => 1,
					],
				],
				'default' => [
					'unit' => 'px',
					'size' => 20,
				],
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button i' => 'font-size: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .hero-slider-arrow button svg' => 'width: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_control(
			'arrows_border_radius',
			[
				'label' => esc_html__( 'Border Radius', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'arrows_box_shadow',
				'label' => esc_html__( 'Box Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .hero-slider-arrow button',
			]
		);

		$this->end_controls_tab();

		// icon hover

		$this->start_controls_tab(
			'arrows_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'techza-hp' ),
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'arrows_hover_background',
				'label' => esc_html__( 'Background', 'techza-hp' ),
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .hero-slider-arrow button:hover',
			]
		);

		$this->add_control(
			'arrows_hover_fill_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button:hover i' => 'color: {{VALUE}}',
					'{{WRAPPER}} .hero-slider-arrow button:hover path' => 'fill: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'arrows_hover_stroke_color',
			[
				'label' => esc_html__( 'Stroke Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .hero-slider-arrow button:hover path' => 'stroke: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'arrows_hover_box_shadow',
				'label' => esc_html__( 'Box Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .hero-slider-arrow button:hover',
			]
		);

		$this->end_controls_tab();
		$this->end_controls_tabs();

		$this->end_controls_section();


		

	}

  protected function render() {
    $settings = $this->get_settings_for_display();
		$contents = $settings['techza_h_slider_list'];
		$h_arrow_prev_icon = $settings['h_arrow_prev_icon'];
		$h_arrow_next_icon = $settings['h_arrow_next_icon'];

		 //this code slider option
		 $slider_extraSetting = array(

			'autoplay' => (!empty($settings['autoplay']) && 'yes' === $settings['autoplay']) ? true : false,
			'arrows' => (!empty($settings['arrows']) && 'yes' === $settings['arrows']) ? true : false,

		);

		$jasondecode = wp_json_encode($slider_extraSetting);
	
			$this->add_render_attribute('techza_slider_active', 'class', array('techza-hero-slider', 't-style'));
			$this->add_render_attribute('techza_slider_active', 'data-settings', $jasondecode);

		?>

	     <section class="techza-hero-slide-section">

			<div <?php echo $this->get_render_attribute_string('techza_slider_active'); ?>>
	            <?php foreach($contents as $content) : ?>
	                <div class="techza-slider-item" style="background-image: url(<?php echo esc_url($content['h_bg_image']['url']);?>)">

	                  <div class="container">
                          <div class="techza-hero-content">
                          	<?php if($content['techza_h_sub_title'] ): ?>
                                  <h5><?php echo esc_html($content['techza_h_sub_title']);  ?></h5>
                              <?php endif; ?>

                              <?php if($content['techza_h_title'] ): ?>
                                  <h1><?php echo esc_html($content['techza_h_title']);  ?></h1>
                              <?php endif; ?>
                              
                              <?php if($content['techza_h_discription'] ): ?>
                                  <p><?php echo esc_html($content['techza_h_discription']); ?></p>
                              <?php endif; ?>
                              
                              <?php if($content['techza_h_btn'] ): ?>
                                  <a class="techza-hero-btn" href="<?php echo esc_url($content['techza_h_btn_link']['url']) ?>"><?php echo esc_html($content['techza_h_btn']); ?></a>
                              <?php endif; ?>
                          </div>
	                  </div>
	              </div>
	              <?php endforeach; ?>
			</div>
		</section>

		<div class="hero-slider-arrow">
			<?php if (!empty($settings['h_arrow_prev_icon']['value'])) : ?>
					<button type="button" class="slick-prev h-prev slick-arrow slick-active">
							<?php \Elementor\Icons_Manager::render_icon($h_arrow_prev_icon, ['aria-hidden' => 'true']);?>
					</button>
			<?php endif; ?>

			<?php if (!empty($settings['h_arrow_next_icon']['value'])) : ?>
					<button type="button" class="slick-next h-next slick-arrow ">
							<?php \Elementor\Icons_Manager::render_icon($h_arrow_next_icon, ['aria-hidden' => 'true']);?>
					</button>
			<?php endif; ?>
		</div>

		<?php
   
  }

}

$widgets_manager->register_widget_type( new \Techza_Hero_slider_Widget() );