<?php

	if (!defined('ABSPATH')) {
		exit;
	}

class Techza_Testimonial_a_slider_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return 'Techza_T_slider';
	}

	public function get_title() {
		return esc_html__( 'Techza T Arrows Slider', 'techza-hp' );
	}

	public function get_icon() {
		return 'eicon-post-slider';
	}

	public function get_categories() {
		return [ 'techza-addons' ];
	}

	public function get_keywords() {
		return [ 'text', 'testimonial', 'infinite', ' slider' ];
	}

  protected function register_controls() {

		$this->start_controls_section(
			'content_section',
			[
				'label' => esc_html__( 'Content', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);


 	$this->add_responsive_control(
            'content_align',
            [
                'label' => __( 'Alignment', 'techza-hp' ),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'options' => [
                    'left' => [
                        'title' => __( 'Left', 'techza-hp' ),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => __( 'Center', 'techza-hp' ),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => __( 'Right', 'techza-hp' ),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'left',
                'selectors' => [
                    '{{WRAPPER}} .techza-t-slider-item' => 'text-align: {{VALUE}};',
                ],
            ]
        );

    $repeater = new \Elementor\Repeater();

		$repeater->add_control(
			'techza_t_thumb',
			[
				'label' => esc_html__( 'Choose Image', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => \Elementor\Utils::get_placeholder_image_src(),
				],
			]
		);


		$repeater->add_control(
			'techza_t_name',
			[
				'label' => esc_html__( 'Name', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'default' => esc_html__( 'title', 'techza-hp' ),
				'placeholder' => esc_html__( 'Type your title here', 'techza-hp' ),
				'label_block' => true,
				'separator' => 'before',
			]
		);

		$repeater->add_control(
			'techza_t_designation',
			[
				'label' => esc_html__( 'Designation', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'default' => esc_html__( 'title', 'techza-hp' ),
				'placeholder' => esc_html__( 'Type your title here', 'techza-hp' ),
				'label_block' => true,
				'separator' => 'before',
			]
		);

		$repeater->add_control(
            'techza_t_discription',
            [
                'label'       => __( 'Discription', 'techza-hp' ),
                'type'        => \Elementor\Controls_Manager::TEXTAREA,
                'label_block' => true,
                'default'     => __('Techmo is an IT solution set of services, software, or hardware bundled together and designed to help businesses manage complex technology operations', 'techza-hp'),
            ]
        );


		$this->add_control(
			'techza_t_slider_list',
			[
				'label' => esc_html__( 'Repeater List', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [
					[
						'techza_t_thumb' => esc_html__( 'Image', 'techza-hp' ),
						'techza_t_name' => esc_html__( 'Karen Lynn', 'techza-hp' ),
						'techza_t_designation' => esc_html__( 'Founder @ Company', 'techza-hp' ),
						'techza_t_discription' => esc_html__( '“Excellent service! Totally friendly and a professional service. Always there to solve any IT problems raised. can highly recommend this company.”', 'techza-hp' ),
					],
				
				],
			]
		);


		$this->end_controls_section();

		// slider arrow

		$this->start_controls_section(
			'slider_content_section',
			[
				'label' => esc_html__( 'Arrows', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			't_arrow_prev_icon',
			[
				'label' => esc_html__( 'Slider Icon Left', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::ICONS,
				'default' => [
					'value' => 'fas fa-star',
					'library' => 'solid',
				],
			]
		);

		$this->add_control(
			't_arrow_next_icon',
			[
				'label' => esc_html__( 'Slider Icon Right', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::ICONS,
				'default' => [
					'value' => 'fas fa-star',
					'library' => 'solid',
				],
			]
		);

		$this->end_controls_section();

		// slider Setting

		$this->start_controls_section(
			'slider_setting_section',
			[
				'label' => esc_html__( 'Setting', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'autoplay',
			[
					'label' => __('Auto Play?', 'techza-hp'),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => __('Show', 'techza-hp'),
					'label_off' => __('Hide', 'techza-hp'),
					'return_value' => 'yes',
					'default' => 'yes',
			]
		);
		$this->add_control(
			'arrows',
			[
					'label' => __('Show arrows?', 'techza-hp'),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => __('Show', 'techza-hp'),
					'label_off' => __('Hide', 'techza-hp'),
					'return_value' => 'yes',
					'default' => 'yes',
			]
		);



		$this->end_controls_section();

		// start style parts

		// Image
		$this->start_controls_section(
			'techza_t_author_thumb',
			[
				'label' => esc_html__( 'Image', 'masco-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_responsive_control(
			't_author_thumb_width',
			[
				'label' => esc_html__( 'Width', 'masco-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .techza-t-author img' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		$this->add_responsive_control(
			't_author_thumb_height_width',
			[
				'label' => esc_html__( 'Height', 'masco-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .techza-t-author img' => 'height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 't_author_thumb_border',
				'label' => esc_html__( 'Border', 'masco-hp' ),
				'selector' => '{{WRAPPER}} .techza-t-author img',
			]
		);

		$this->add_responsive_control(
			't_author_thumb_border_radius',
			[
				'label' => esc_html__( 'Border Radius', 'masco-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-t-author img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);


		$this->end_controls_section();
		// end image style

			// Title
		$this->start_controls_section(
			't_name_style',
			[
				'label' => esc_html__( 'Name', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_control(
			't_name_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-t-author-data h4' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 't_name_typography',
				'selector' => '{{WRAPPER}} .techza-t-author-data h4',
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Text_Shadow::get_type(),
			[
				'name' => 't_name_text_shadow',
				'label' => esc_html__( 'Text Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-t-author-data h4',
			]
		);

		$this->add_control(
			't_name_margin',
			[
				'label' => esc_html__( 'Margin', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-t-author-data h4' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End title style

		// Descriptions 
		$this->start_controls_section(
			't_designation_style',
			[
				'label' => esc_html__( 'Designation', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_control(
			't_designation_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-t-author-data span' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 't_designation_typography',
				'selector' => '{{WRAPPER}} .techza-t-author-data span',
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Text_Shadow::get_type(),
			[
				'name' => 't_designation_text_shadow',
				'label' => esc_html__( 'Text Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-t-author-data span',
			]
		);

		$this->add_control(
			't_designation_margin',
			[
				'label' => esc_html__( 'Margin', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-t-author-data span' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End designation style

		// Descriptions 
		$this->start_controls_section(
			't_descriptions_style',
			[
				'label' => esc_html__( 'Description', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_control(
			't_descriptions_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .techza-t-slider-item p' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 't_descriptions_typography',
				'selector' => '{{WRAPPER}} .techza-t-slider-item p',
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Text_Shadow::get_type(),
			[
				'name' => 't_descriptions_text_shadow',
				'label' => esc_html__( 'Text Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .techza-t-slider-item p',
			]
		);

		$this->add_control(
			't_descriptions_margin',
			[
				'label' => esc_html__( 'Margin', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-t-slider-item p' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End descriptions style

		//  box 
		$this->start_controls_section(
			't_box_style',
			[
				'label' => esc_html__( 'Box', 'masco-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		 $this->add_control(
            't_box_bg',
            [
                'label' => __('Background Color', 'techza-hp'),
                'type' => \Elementor\Controls_Manager::COLOR,
                'selectors' => [
                    '{{WRAPPER}} .techza-t-slider-item' => 'background-color: {{VALUE}}',
                ],
            ]
        );

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 't_box_border',
				'label' => esc_html__( 'Border', 'masco-hp' ),
				'selector' => '{{WRAPPER}} .techza-t-slider-item',
			]
		);


		$this->add_control(
			't_box_radius',
			[
				'label' => esc_html__( 'Border Radius', 'masco-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-t-slider-item' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_responsive_control(
			't_box_padding',
			[
				'label' => esc_html__( 'Padding', 'masco-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .techza-t-slider-item' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();
		// End box style


		// slider arrows
		$this->start_controls_section(
			'icon_style_section',
			[
				'label' => esc_html__( 'Arrows', 'techza-hp' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->start_controls_tabs(
			'arrows_style_tabs'
		);

		$this->start_controls_tab(
			'arrow_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'techza-hp' ),
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'arrow_background',
				'label' => esc_html__( 'Background', 'techza-hp' ),
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .t-slider-arrow button',
			]
		);

		$this->add_control(
			'arrow_fill_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button i' => 'color: {{VALUE}}',
					'{{WRAPPER}} .t-slider-arrow button path' => 'fill: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'arrow_stroke_color',
			[
				'label' => esc_html__( 'Stroke Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button path' => 'stroke: {{VALUE}}',
				],
			]
		);

		$this->add_responsive_control(
			'arrows_width',
			[
				'label' => esc_html__( 'Width', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
				
				],
		
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_responsive_control(
			'arrows_height',
			[
				'label' => esc_html__( 'Height', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
				
				],
		
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button' => 'height: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_control(
			'arrows_size',
			[
				'label' => esc_html__( 'Size', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px'],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 100,
						'step' => 1,
					],
				],
				'default' => [
					'unit' => 'px',
					'size' => 20,
				],
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button i' => 'font-size: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .t-slider-arrow button svg' => 'width: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'arrows_borde',
				'label' => esc_html__( 'Border', 'masco-hp' ),
				'selector' => '{{WRAPPER}} .t-slider-arrow button',
			]
		);

		$this->add_control(
			'arrows_border_radius',
			[
				'label' => esc_html__( 'Border Radius', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
				'separator' => 'before'
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'arrows_box_shadow',
				'label' => esc_html__( 'Box Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .t-slider-arrow button',
			]
		);

		$this->end_controls_tab();

		// icon hover

		$this->start_controls_tab(
			'arrows_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'techza-hp' ),
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'arrows_hover_background',
				'label' => esc_html__( 'Background', 'techza-hp' ),
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .t-slider-arrow button:hover',
			]
		);

		$this->add_control(
			'arrows_hover_fill_color',
			[
				'label' => esc_html__( 'Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button:hover i' => 'color: {{VALUE}}',
					'{{WRAPPER}} .t-slider-arrow button:hover path' => 'fill: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'arrows_hover_stroke_color',
			[
				'label' => esc_html__( 'Stroke Color', 'techza-hp' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .t-slider-arrow button:hover path' => 'stroke: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'arrows_border_hover',
				'label' => esc_html__( 'Border', 'masco-hp' ),
				'selector' => '{{WRAPPER}} .t-slider-arrow button:hover',
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'arrows_hover_box_shadow',
				'label' => esc_html__( 'Box Shadow', 'techza-hp' ),
				'selector' => '{{WRAPPER}} .t-slider-arrow button:hover',
			]
		);

		$this->end_controls_tab();
		$this->end_controls_tabs();

		$this->end_controls_section();


		

	}

  protected function render() {
    $settings = $this->get_settings_for_display();
		$contents = $settings['techza_t_slider_list'];
		$t_arrow_prev_icon = $settings['t_arrow_prev_icon'];
		$t_arrow_next_icon = $settings['t_arrow_next_icon'];

		 //this code slider option
		 $slider_extraSetting = array(

			'autoplay' => (!empty($settings['autoplay']) && 'yes' === $settings['autoplay']) ? true : false,
			'arrows' => (!empty($settings['arrows']) && 'yes' === $settings['arrows']) ? true : false,

		);

		$jasondecode = wp_json_encode($slider_extraSetting);
	
			$this->add_render_attribute('techza_slider_active', 'class', array('techza-t-slider', 't-style'));
			$this->add_render_attribute('techza_slider_active', 'data-settings', $jasondecode);

		?>

			<div class="techza-t-slider-wrap">
				<div <?php echo $this->get_render_attribute_string('techza_slider_active'); ?>>
		            <?php foreach($contents as $content) : ?>
		                  <div class="techza-t-slider-item">
		                  	<div class="techza-t-author-wrap">
		                  		<div class="techza-t-author">
			                  		<?php if($content['techza_t_thumb'] ): ?>
			                  			<img src="<?php echo esc_url($content['techza_t_thumb']['url']) ?>" alt="">
			                  		<?php endif; ?>
			                  	</div>
			                  	<div class="techza-t-author-data">
			                  		<?php if($content['techza_t_name'] ): ?>
			                          <h4><?php echo esc_html($content['techza_t_name']);  ?></h4>
			                      	<?php endif; ?>

			                      	<?php if($content['techza_t_designation'] ): ?>
			                          <span><?php echo esc_html($content['techza_t_designation']);  ?></span>
			                      	<?php endif; ?>
			                  	</div>
		                  	</div>
		                  	
		                  	<?php if($content['techza_t_discription'] ): ?>
		                        <p><?php echo esc_html($content['techza_t_discription']); ?></p>
		                     <?php endif; ?>

		                  </div>

		              <?php endforeach; ?>
				</div>
			</div>
			

			<div class="t-slider-arrow">
				<?php if (!empty($settings['t_arrow_prev_icon']['value'])) : ?>
					<button type="button" class="slick-prev t-prev slick-arrow slick-active">
						<?php \Elementor\Icons_Manager::render_icon($t_arrow_prev_icon, ['aria-hidden' => 'true']);?>
					</button>
				<?php endif; ?>

				<?php if (!empty($settings['t_arrow_next_icon']['value'])) : ?>
					<button type="button" class="slick-next t-next slick-arrow ">
						<?php \Elementor\Icons_Manager::render_icon($t_arrow_next_icon, ['aria-hidden' => 'true']);?>
					</button>
				<?php endif; ?>
			</div>

		<?php
   
  }

}

$widgets_manager->register_widget_type( new \Techza_Testimonial_a_slider_Widget() );